﻿-- REQUIRED Combuctor
local CombuctorSet = Combuctor:GetModule("Sets")
local L = LibStub('AceLocale-3.0'):GetLocale('Combuctor')

-- Profession Icon Name
local IconPathName="Interface/Icons/Trade_engineering"

-- AucItemClasses
local Class_Recipe					=select(7, GetAuctionItemClasses())

-- AucItemSubClasses
local SubClass_Materials			=select(12, GetAuctionItemSubClasses(6))
local SubClass_Parts				=select(9, GetAuctionItemSubClasses(6))
local SubClass_Guns					=select(4, GetAuctionItemSubClasses(1))
local SubClass_Scopes				=select(10, GetAuctionItemSubClasses(6))
local SubClass_Pets					=select(3, GetAuctionItemSubClasses(9))
local SubClass_Other				=select(5, GetAuctionItemSubClasses(9))
local SubClass_Recipe_Engeneering	=select(4, GetAuctionItemSubClasses(7))

-- Tab Names
local TN={}
TN.Engeneering=SubClass_Recipe_Engeneering
TN.All=ALL 								-- Источник==Инженерное дело ИЛИ Используется==Инженерное дело или Рецепт
-- Материалы
TN.Materials=SubClass_Materials 		-- Используется==Инженерном деле И НЕ Источник~=Инженерное дело
TN.Parts=SubClass_Parts			 		-- Используется==Инженерном деле И Источник==Инженерное дело
-- Продукты
TN.Guns=SubClass_Guns					-- Огнестрельное оружие (все) + Прицелы (crafted)
TN.Pets=SubClass_Pets					-- Питомцы (все, а не только Инженерные)
TN.Products=SubClass_Other				-- Источник==Инженерное дело И НЕ PEt И НЕ Guns
-- Рецепты
TN.Recipes=Class_Recipe					-- Рецепты для Инженерного дела

local ItemID
-----------------------------------------------------------------------------------------------------------------------------------------
local function GetItemIDFromLink(itemLink)
	if not itemLink or itemLink=="" then return nil end

	local itemString = string.match(itemLink, "item[%-?%d:]+")
	if not itemString then return nil end
	
	local linkType, itemId, enchantId,jewelId1, jewelId2, jewelId3, jewelId4,suffixId, uniqueId = strsplit(":", itemString)
	if (linkType == 'item') then
		return itemId
	end
	return nil
end
-----------------------------------------------------------------------------------------------------------------------------------------
local function isEngeneering(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not link then return false end

	ItemID=GetItemIDFromLink(link)
	if not ItemID then return false end

	return (ReagentsForEngeneering[tonumber(ItemID)] or CraftedByEngeneering[tonumber(ItemID)] or subType==SubClass_Guns or subType==SubClass_Pets or subType==SubClass_Recipe_Engeneering)
end
-----------------------------------------------------------------------------------------------------------------------------------------
local function isMaterial(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end

	ItemID=GetItemIDFromLink(link)
	if not ItemID then return false end

	return (ReagentsForEngeneering[tonumber(ItemID)] and CraftedByEngeneering[tonumber(ItemID)]==nil)
end
-----------------------------------------------------------------------------------------------------------------------------------------
local function isPart(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not link then return false end
	if not subType then return false end

	ItemID=GetItemIDFromLink(link)
	if not ItemID then return false end

	return (ReagentsForEngeneering[tonumber(ItemID)] and CraftedByEngeneering[tonumber(ItemID)])
end
-----------------------------------------------------------------------------------------------------------------------------------------
local function isPet(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	return (subType==SubClass_Pets)
end
-----------------------------------------------------------------------------------------------------------------------------------------
local function isGun(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	
	ItemID=GetItemIDFromLink(link)
	if not ItemID then return false end
	if ItemID==nil then return false end
		
	return (subType==SubClass_Guns or CraftedByEngeneeringScopes[tonumber(ItemID)]~=nil)
end
-----------------------------------------------------------------------------------------------------------------------------------------
local function isProduct(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not link then return false end
	if not subType then return false end

	ItemID=GetItemIDFromLink(link)
	if not ItemID then return false end

	return (CraftedByEngeneering[tonumber(ItemID)] and ReagentsForEngeneering[tonumber(ItemID)]==nil and CraftedByEngeneeringScopes[tonumber(ItemID)]==nil and subType~=SubClass_Guns and subType~=SubClass_Pets)
end
-----------------------------------------------------------------------------------------------------------------------------------------
local function isRecipe(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not type then return false end
	if not subType then return false end
	return (type==Class_Recipe and subType==SubClass_Recipe_Engeneering)
end
-----------------------------------------------------------------------------------------------------------------------------------------
CombuctorSet:Register(TN.Engeneering, IconPathName, isEngeneering)

CombuctorSet:RegisterSubSet(TN.All,			TN.Engeneering,nil,isEngeneering)
CombuctorSet:RegisterSubSet(TN.Materials,	TN.Engeneering,nil,isMaterial)
CombuctorSet:RegisterSubSet(TN.Parts,		TN.Engeneering,nil,isPart)
CombuctorSet:RegisterSubSet(TN.Pets,		TN.Engeneering,nil,isPet)
CombuctorSet:RegisterSubSet(TN.Guns,		TN.Engeneering,nil,isGun)
CombuctorSet:RegisterSubSet(TN.Products,	TN.Engeneering,nil,isProduct)
CombuctorSet:RegisterSubSet(TN.Recipes,		TN.Engeneering,nil,isRecipe)
